Liferay.Loader.define('commerce-frontend-js@3.0.30/components/dataset_display/management_bar/actions/index', ['module', 'exports', 'require'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = exports.actions = exports.actionsDefinition = void 0;

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    var actionsDefinition = {
      RESET_FILTERS_VALUE: 'resetFiltersValue',
      UPDATE_FILTER_STATE: 'updateFilterState'
    };
    exports.actionsDefinition = actionsDefinition;

    var updateFilterState = function updateFilterState(dispatch) {
      return function (id) {
        var value = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
        var formattedValue = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
        var odataFilterString = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
        return dispatch({
          payload: {
            formattedValue: formattedValue,
            id: id,
            odataFilterString: odataFilterString,
            value: value
          },
          type: actionsDefinition.UPDATE_FILTER_STATE
        });
      };
    };

    var resetFiltersValue = function resetFiltersValue(dispatch) {
      return function () {
        return dispatch({
          type: actionsDefinition.RESET_FILTERS_VALUE
        });
      };
    };

    var actions = {
      resetFiltersValue: resetFiltersValue,
      updateFilterState: updateFilterState
    };
    exports.actions = actions;
    var _default = actions;
    exports.default = _default;
    //# sourceMappingURL=index.js.map
  }
});
//# sourceMappingURL=index.js.map