Liferay.Loader.define("commerce-frontend-js@3.0.30/components/mini_cart/CartItemsListActions", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/button', 'frontend-js-react-web$classnames', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react', '../../utilities/eventsDefinitions', '../../utilities/index', './MiniCartContext', './util/constants'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _button = _interopRequireDefault(require("@frontend-taglib-clay$clayui/button"));

    var _classnames = _interopRequireDefault(require("frontend-js-react-web$classnames"));

    var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _eventsDefinitions = require("../../utilities/eventsDefinitions");

    var _index = require("../../utilities/index");

    var _MiniCartContext = _interopRequireDefault(require("./MiniCartContext"));

    var _constants = require("./util/constants");

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    function CartItemsListActions(_ref) {
      var numberOfItems = _ref.numberOfItems;

      var _useContext = (0, _react.useContext)(_MiniCartContext.default),
          CartResource = _useContext.CartResource,
          actionURLs = _useContext.actionURLs,
          cartState = _useContext.cartState,
          labels = _useContext.labels,
          setIsUpdating = _useContext.setIsUpdating,
          updateCartModel = _useContext.updateCartModel;

      var orderId = cartState.id;
      var orderDetailURL = actionURLs.orderDetailURL;

      var _useState = (0, _react.useState)(false),
          _useState2 = _slicedToArray(_useState, 2),
          isAsking = _useState2[0],
          setIsAsking = _useState2[1];

      return (/*#__PURE__*/_react.default.createElement("div", {
          className: 'mini-cart-header'
        }, /*#__PURE__*/_react.default.createElement("div", {
          className: 'mini-cart-header-block'
        }, /*#__PURE__*/_react.default.createElement("div", {
          className: 'mini-cart-header-resume'
        }, numberOfItems > 0 && /*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("span", {
          className: 'items'
        }, numberOfItems), " ".concat(numberOfItems > 1 ? Liferay.Language.get('products') : Liferay.Language.get('product')))), /*#__PURE__*/_react.default.createElement("div", {
          className: 'mini-cart-header-actions'
        }, /*#__PURE__*/_react.default.createElement("span", {
          className: (0, _classnames.default)('actions', isAsking && 'hide')
        }, /*#__PURE__*/_react.default.createElement(_button.default, {
          className: 'action',
          disabled: !numberOfItems,
          displayType: 'link',
          onClick: function onClick() {
            (0, _index.liferayNavigate)(orderDetailURL);
          },
          small: true
        }, labels[_constants.VIEW_DETAILS]), /*#__PURE__*/_react.default.createElement(_button.default, {
          className: 'action',
          disabled: !numberOfItems,
          displayType: 'link',
          onClick: function askConfirmation() {
            return setIsAsking(true);
          },
          small: true
        }, labels[_constants.REMOVE_ALL_ITEMS])), /*#__PURE__*/_react.default.createElement("div", {
          className: (0, _classnames.default)('confirmation-prompt', !isAsking && 'hide')
        }, /*#__PURE__*/_react.default.createElement("span", null, Liferay.Language.get('are-you-sure')), /*#__PURE__*/_react.default.createElement("span", null, /*#__PURE__*/_react.default.createElement("button", {
          className: 'btn btn-outline-success btn-sm',
          onClick: function flushCart() {
            setIsUpdating(true);
            CartResource.updateCartById(orderId, {
              cartItems: []
            }).then(function () {
              return updateCartModel({
                orderId: orderId
              });
            }).then(function () {
              setIsAsking(false);
              setIsUpdating(false);
              Liferay.fire(_eventsDefinitions.PRODUCT_REMOVED, {
                skuId: 'all'
              });
            });
          },
          type: 'button'
        }, Liferay.Language.get('yes')), /*#__PURE__*/_react.default.createElement("button", {
          className: 'btn btn-outline-danger btn-sm',
          onClick: function cancel() {
            return setIsAsking(false);
          },
          type: 'button'
        }, Liferay.Language.get('no')))))))
      );
    }

    var _default = CartItemsListActions;
    exports.default = _default;
    //# sourceMappingURL=CartItemsListActions.js.map
  }
});
//# sourceMappingURL=CartItemsListActions.js.map