Liferay.Loader.define('commerce-frontend-js@3.0.30/utilities/notifications', ['module', 'exports', 'require'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.showNotification = showNotification;
    exports.showErrorNotification = showErrorNotification;

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    function showNotification(message) {
      var type = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'success';
      var closeable = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : true;
      var duration = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 500;

      if (!window.AUI) {
        return;
      }

      AUI().use('liferay-notification', function () {
        new Liferay.Notification({
          closeable: closeable,
          delay: {
            hide: 5000,
            show: 0
          },
          duration: duration,
          message: message,
          render: true,
          title: Liferay.Language.get(type),
          type: type
        });
      });
    }

    function showErrorNotification() {
      var e = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Liferay.Language.get('unexpected-error');
      showNotification(e, 'danger');
    }
    //# sourceMappingURL=notifications.js.map
  }
});
//# sourceMappingURL=notifications.js.map