Liferay.Loader.define("commerce-organization-web@4.0.23/js/components/InfiniteScroll", ['module', 'exports', 'require', 'frontend-js-web', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react', '../utils/utils', '../utils/window'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _frontendJsWeb = require("frontend-js-web");

    var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _utils = require("../utils/utils");

    var _window = _interopRequireDefault(require("../utils/window"));

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    function _classCallCheck(instance, Constructor) {
      if (!(instance instanceof Constructor)) {
        throw new TypeError("Cannot call a class as a function");
      }
    }

    function _defineProperties(target, props) {
      for (var i = 0; i < props.length; i++) {
        var descriptor = props[i];descriptor.enumerable = descriptor.enumerable || false;descriptor.configurable = true;if ("value" in descriptor) descriptor.writable = true;Object.defineProperty(target, descriptor.key, descriptor);
      }
    }

    function _createClass(Constructor, protoProps, staticProps) {
      if (protoProps) _defineProperties(Constructor.prototype, protoProps);if (staticProps) _defineProperties(Constructor, staticProps);return Constructor;
    }

    function _possibleConstructorReturn(self, call) {
      if (call && (_typeof(call) === "object" || typeof call === "function")) {
        return call;
      }return _assertThisInitialized(self);
    }

    function _getPrototypeOf(o) {
      _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) {
        return o.__proto__ || Object.getPrototypeOf(o);
      };return _getPrototypeOf(o);
    }

    function _assertThisInitialized(self) {
      if (self === void 0) {
        throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
      }return self;
    }

    function _inherits(subClass, superClass) {
      if (typeof superClass !== "function" && superClass !== null) {
        throw new TypeError("Super expression must either be null or a function");
      }subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } });if (superClass) _setPrototypeOf(subClass, superClass);
    }

    function _setPrototypeOf(o, p) {
      _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) {
        o.__proto__ = p;return o;
      };return _setPrototypeOf(o, p);
    }

    var InfiniteScroll = /*#__PURE__*/function (_Component) {
      _inherits(InfiniteScroll, _Component);

      function InfiniteScroll(props) {
        var _this;

        _classCallCheck(this, InfiniteScroll);

        _this = _possibleConstructorReturn(this, _getPrototypeOf(InfiniteScroll).call(this, props));
        (0, _utils.bindAll)(_assertThisInitialized(_this), 'handleScroll_', 'shouldScroll_');
        _this.debouncedScrollHandler_ = (0, _frontendJsWeb.debounce)(_this.handleScroll_, props.wait);
        return _this;
      }

      _createClass(InfiniteScroll, [{
        key: "componentDidMount",
        value: function componentDidMount() {
          this.attachScrollHandler_();

          if (this.props.hasMoreResults) {
            this.debouncedScrollHandler_();
          }
        }
      }, {
        key: "componentWillUnmount",
        value: function componentWillUnmount() {
          if (this._request) {
            this._request.cancel();
          }

          this.debouncedScrollHandler_.cancel();
          this.detachScrollHandler_();
        }
      }, {
        key: "attachScrollHandler_",
        value: function attachScrollHandler_(forceAttach) {
          var _this$props = this.props,
              attachToElement = _this$props.attachToElement,
              hasMoreResults = _this$props.hasMoreResults;

          if (hasMoreResults || forceAttach) {
            attachToElement().addEventListener('scroll', this.debouncedScrollHandler_);
          }
        }
      }, {
        key: "detachScrollHandler_",
        value: function detachScrollHandler_() {
          this.props.attachToElement().removeEventListener('scroll', this.debouncedScrollHandler_);
        }
      }, {
        key: "handleScroll_",
        value: function handleScroll_() {
          var _this2 = this;

          var onScrollEnd = this.props.onScrollEnd;

          if (!this.state.loading_ && onScrollEnd && this.shouldScroll_()) {
            this.setState({
              loading_: true
            });
            this._request = onScrollEnd().then(function () {
              _this2.setState({
                loading_: false
              });
            });
          }
        }
      }, {
        key: "shouldScroll_",
        value: function shouldScroll_() {
          var shouldScroll = false;
          var scrollContainer = this.element;

          if (scrollContainer && scrollContainer.offsetParent) {
            shouldScroll = scrollContainer.getBoundingClientRect().bottom - _window.default.innerHeight - this.props.scrollOffset < 0;
          }

          return shouldScroll;
        }
      }, {
        key: "syncHasMoreResults",
        value: function syncHasMoreResults(value) {
          if (value) {
            this.attachScrollHandler_(value);
          } else {
            this.debouncedScrollHandler_.cancel();
            this.detachScrollHandler_();
          }
        }
      }, {
        key: "render",
        value: function render() {
          return (/*#__PURE__*/_react.default.createElement("div", null, this.props.children)
          );
        }
      }]);

      return InfiniteScroll;
    }(_react.Component);

    InfiniteScroll.defaultProps = {
      attachToElement: function attachToElement() {
        return _window.default;
      },
      hasMoreResults: true,
      loading_: false,
      scrollOffset: 0,
      wait: 100
    };
    var _default = InfiniteScroll;
    exports.default = _default;
    //# sourceMappingURL=InfiniteScroll.js.map
  }
});
//# sourceMappingURL=InfiniteScroll.js.map