Liferay.Loader.define("app-builder-workflow-web@1.0.40/js/hooks/useDDMForms.es", ['module', 'exports', 'require', 'dynamic-data-mapping-form-renderer', 'frontend-js-react-web$react'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.useDDMFormsSubmit = useDDMFormsSubmit;
    exports.useDDMFormsValidation = useDDMFormsValidation;
    exports.default = useDDMForms;

    var _dynamicDataMappingFormRenderer = require("dynamic-data-mapping-form-renderer");

    var _react = require("frontend-js-react-web$react");

    function ownKeys(object, enumerableOnly) {
      var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });keys.push.apply(keys, symbols);
      }return keys;
    }

    function _objectSpread(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
          ownKeys(Object(source), true).forEach(function (key) {
            _defineProperty(target, key, source[key]);
          });
        } else if (Object.getOwnPropertyDescriptors) {
          Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
        } else {
          ownKeys(Object(source)).forEach(function (key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
          });
        }
      }return target;
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }return obj;
    }

    function useDDMFormsSubmit(ddmForms, onSubmit) {
      (0, _react.useEffect)(function () {
        var forms = ddmForms.map(function (ddmForm) {
          return ddmForm.reactComponentRef.current.getFormNode();
        });
        forms.forEach(function (formNode) {
          return formNode.addEventListener('submit', onSubmit);
        });
        return function () {
          forms.forEach(function (form) {
            return form.removeEventListener('submit', onSubmit);
          });
        };
      }, [ddmForms, onSubmit]);
    }

    function useDDMFormsValidation(ddmForms, languageId, availableLanguageIds) {
      var getFormsValues = (0, _react.useCallback)(function (ddmReactForms) {
        var dataRecordValues = {};
        ddmReactForms.forEach(function (ddmReactForm) {
          var visitor = new _dynamicDataMappingFormRenderer.PagesVisitor(ddmReactForm.get('pages'));

          visitor.mapFields(function setDataRecord(_ref) {
            var fieldName = _ref.fieldName,
                repeatable = _ref.repeatable,
                type = _ref.type,
                value = _ref.value,
                visible = _ref.visible;

            if (type === 'fieldset') {
              return;
            }

            if (!visible) {
              value = '';
            }

            if (!dataRecordValues[fieldName]) {
              dataRecordValues[fieldName] = _defineProperty({}, languageId, []);
            }

            if (repeatable) {
              dataRecordValues[fieldName][languageId].push(value);
            } else {
              dataRecordValues[fieldName] = _defineProperty({}, languageId, value);
            }

            availableLanguageIds.forEach(function (key) {
              dataRecordValues[fieldName][key] = dataRecordValues[fieldName][languageId];
            });
          }, true, true);
        });
        return {
          dataRecordValues: dataRecordValues
        };
      }, [availableLanguageIds, languageId]);

      var validateForms = function validateForms(ddmReactForms) {
        return ddmReactForms.map(function (_ref2) {
          var validate = _ref2.validate;
          return validate;
        }).reduce(function (promises, validate) {
          return promises.then(function (result) {
            return validate().then(Array.prototype.concat.bind(result));
          });
        }, Promise.resolve([])).then(function (validations) {
          return validations.every(function (isValid) {
            return isValid;
          });
        });
      };

      return (0, _react.useCallback)(function (event) {
        return new Promise(function (resolve, reject) {
          if (typeof event.stopImmediatePropagation === 'function') {
            event.stopImmediatePropagation();
          }

          var ddmReactForms = ddmForms.map(function (ddmForm) {
            return ddmForm.reactComponentRef.current;
          });
          validateForms(ddmReactForms).then(function (isValid) {
            if (isValid) {
              resolve(getFormsValues(ddmReactForms));
            } else {
              reject();
            }
          }).catch(reject);
        });
      }, [ddmForms, getFormsValues]);
    }

    function useDDMForms(containerElementIds) {
      var _useState = (0, _react.useState)({}),
          _useState2 = _slicedToArray(_useState, 2),
          ddmForms = _useState2[0],
          setDdmForms = _useState2[1];

      containerElementIds.forEach(function (containerElementId) {
        if (!ddmForms[containerElementId]) {
          Liferay.componentReady(containerElementId).then(function (ddmForm) {
            setDdmForms(function (prevForms) {
              return _objectSpread(_objectSpread({}, prevForms), {}, _defineProperty({}, containerElementId, ddmForm));
            });
          });
        }
      });
      return (0, _react.useMemo)(function () {
        return Object.values(ddmForms);
      }, [ddmForms]);
    }
    //# sourceMappingURL=useDDMForms.es.js.map
  }
});
//# sourceMappingURL=useDDMForms.es.js.map