Liferay.Loader.define("data-engine-taglib@2.5.29/data_layout_builder/js/data-layout-builder/DataLayoutBuilderContextProvider.es", ['module', 'exports', 'require', 'dynamic-data-mapping-form-renderer', 'frontend-js-react-web$react', '../AppContext.es', '../actions.es', '../drag-and-drop/getDropHandler.es', './DataLayoutBuilderContext.es'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _dynamicDataMappingFormRenderer = require("dynamic-data-mapping-form-renderer");

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _AppContext = _interopRequireDefault(require("../AppContext.es"));

    var _actions = require("../actions.es");

    var _getDropHandler = require("../drag-and-drop/getDropHandler.es");

    var _DataLayoutBuilderContext = _interopRequireDefault(require("./DataLayoutBuilderContext.es"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    var _default = function _default(_ref) {
      var children = _ref.children,
          dataLayoutBuilder = _ref.dataLayoutBuilder;

      var _useContext = (0, _react.useContext)(_AppContext.default),
          _useContext2 = _slicedToArray(_useContext, 2),
          dataDefinition = _useContext2[0].dataDefinition,
          dispatch = _useContext2[1];

      (0, _react.useEffect)(function () {
        var provider = dataLayoutBuilder.getLayoutProvider();
        var eventHandler = provider.on('editingLanguageIdChanged', function (_ref2) {
          var newVal = _ref2.newVal;
          provider.once('rendered', function () {
            dispatch({
              payload: newVal,
              type: _actions.UPDATE_EDITING_LANGUAGE_ID
            });
          });
        });
        return function () {
          return eventHandler.removeListener();
        };
      }, [dataLayoutBuilder, dispatch]);
      (0, _react.useEffect)(function () {
        var provider = dataLayoutBuilder.getLayoutProvider();
        var eventHandler = provider.on('focusedFieldChanged', function (_ref3) {
          var newVal = _ref3.newVal;
          dispatch({
            payload: {
              focusedField: newVal
            },
            type: _actions.UPDATE_FOCUSED_FIELD
          });
        });
        return function () {
          return eventHandler.removeListener();
        };
      }, [dataLayoutBuilder, dispatch]);
      (0, _react.useEffect)(function () {
        var provider = dataLayoutBuilder.getLayoutProvider();
        var eventHandler = provider.on('fieldHovered', function (newVal) {
          dispatch({
            payload: {
              hoveredField: newVal
            },
            type: _actions.UPDATE_HOVERED_FIELD
          });
        });
        return function () {
          return eventHandler.removeListener();
        };
      }, [dataLayoutBuilder, dispatch]);
      (0, _react.useEffect)(function () {
        var provider = dataLayoutBuilder.getLayoutProvider();
        var eventHandler = provider.on('pagesChanged', function (_ref4) {
          var newVal = _ref4.newVal;
          dispatch({
            payload: {
              pages: newVal
            },
            type: _actions.UPDATE_PAGES
          });
        });
        return function () {
          return eventHandler.removeListener();
        };
      }, [dataLayoutBuilder, dispatch]);
      (0, _react.useEffect)(function () {
        var provider = dataLayoutBuilder.getLayoutProvider();
        var ruleAddedEventHandler = provider.on('ruleAdded', function (dataRule) {
          provider.once('rendered', function () {
            dispatch({
              payload: {
                dataRule: dataRule
              },
              type: _actions.ADD_DATA_LAYOUT_RULE
            });
          });
        });
        var ruleEditedEventHandler = provider.on('ruleEdited', function (dataRule) {
          provider.once('rendered', function () {
            dispatch({
              payload: {
                dataRule: dataRule
              },
              type: _actions.UPDATE_DATA_LAYOUT_RULE
            });
          });
        });
        return function () {
          ruleAddedEventHandler.removeListener();
          ruleEditedEventHandler.removeListener();
        };
      }, [dataLayoutBuilder, dispatch]);
      (0, _react.useEffect)(function () {
        var fieldTypes = dataLayoutBuilder.getFieldTypes();
        dispatch({
          payload: {
            fieldTypes: fieldTypes
          },
          type: _actions.UPDATE_FIELD_TYPES
        });
      }, [dataLayoutBuilder, dispatch]);
      (0, _react.useEffect)(function () {
        var provider = dataLayoutBuilder.getLayoutProvider();
        var onDrop = (0, _getDropHandler.getDropHandler)({
          dataDefinition: dataDefinition,
          dataLayoutBuilder: dataLayoutBuilder
        });
        var eventHandler = provider.on(_dynamicDataMappingFormRenderer.EVENT_TYPES.FIELD_DROP, onDrop);
        return function () {
          return eventHandler.removeListener();
        };
      }, [dataLayoutBuilder, dataDefinition]);
      return (/*#__PURE__*/_react.default.createElement(_DataLayoutBuilderContext.default.Provider, {
          value: [dataLayoutBuilder, dataLayoutBuilder.dispatch]
        }, children)
      );
    };

    exports.default = _default;
    //# sourceMappingURL=DataLayoutBuilderContextProvider.es.js.map
  }
});
//# sourceMappingURL=DataLayoutBuilderContextProvider.es.js.map