Liferay.Loader.define("data-engine-taglib@2.5.29/data_layout_builder/js/utils/toast.es", ['module', 'exports', 'require', 'frontend-js-web'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.successToast = exports.errorToast = void 0;

    var _frontendJsWeb = require("frontend-js-web");

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    var errorToast = function errorToast() {
      var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Liferay.Language.get('an-unexpected-error-occurred');
      var title = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : Liferay.Language.get('error');
      (0, _frontendJsWeb.openToast)({
        message: message,
        title: "".concat(title),
        type: 'danger'
      });
    };

    exports.errorToast = errorToast;

    var successToast = function successToast() {
      var message = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : Liferay.Language.get('your-request-completed-successfully');
      var title = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : Liferay.Language.get('success');
      (0, _frontendJsWeb.openToast)({
        message: message,
        title: "".concat(title),
        type: 'success'
      });
    };

    exports.successToast = successToast;
    //# sourceMappingURL=toast.es.js.map
  }
});
//# sourceMappingURL=toast.es.js.map