Liferay.Loader.define('dynamic-data-mapping-form-renderer@5.0.47/js/util/fields.es', ['module', 'exports', 'require'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.normalizeFieldName = normalizeFieldName;
    exports.checkInvalidFieldNameCharacter = void 0;

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    var checkInvalidFieldNameCharacter = function checkInvalidFieldNameCharacter(character) {
      return (/[\\~`!@#$%^&*(){}[\];:"'<,.>?/\-+=|]/g.test(character)
      );
    };

    exports.checkInvalidFieldNameCharacter = checkInvalidFieldNameCharacter;

    function normalizeFieldName(fieldName) {
      var nextUpperCase = false;
      var normalizedFieldName = '';
      fieldName = fieldName.trim();

      for (var i = 0; i < fieldName.length; i++) {
        var item = fieldName[i];

        if (item === ' ') {
          nextUpperCase = true;
          continue;
        } else if (checkInvalidFieldNameCharacter(item)) {
          continue;
        }

        if (nextUpperCase) {
          item = item.toUpperCase();
          nextUpperCase = false;
        }

        normalizedFieldName += item;
      }

      if (/^\d/.test(normalizedFieldName)) {
        normalizedFieldName = "_".concat(normalizedFieldName);
      }

      return normalizedFieldName;
    }
    //# sourceMappingURL=fields.es.js.map
  }
});
//# sourceMappingURL=fields.es.js.map