Liferay.Loader.define("layout-seo-web@1.0.45/js/seo/display_page_templates/hooks/useOnClickOutside", ['module', 'exports', 'require', 'frontend-js-react-web$react'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = useOnClickOutside;

    var _react = _interopRequireDefault(require("frontend-js-react-web$react"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    var useEffect = _react.default.useEffect;

    function useOnClickOutside(elements, handler) {
      useEffect(function () {
        var listener = function listener(event) {
          /**
           * Detect clicks on elements or their descendent elements.
           */
          var filtered = elements.filter(function (element) {
            return element && element.contains(event.target);
          });

          if (!filtered.length) {
            handler(event);
          }
        };

        document.addEventListener('mousedown', listener);
        document.addEventListener('touchstart', listener);
        return function () {
          document.removeEventListener('mousedown', listener);
          document.removeEventListener('touchstart', listener);
        };
      }, [elements, handler]);
    }
    //# sourceMappingURL=useOnClickOutside.js.map
  }
});
//# sourceMappingURL=useOnClickOutside.js.map